// calc.cpp: implementation of the calc class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "calc.h"
#include "string.h"
#include "ctype.h"
#include "math.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

calc::calc()
{
 memset(Function,0,256);
 pCurrPos=Function;
}

calc::~calc()
{

}

calc::calc(char* lpszCommand)
{
	SetFunction(lpszCommand);
}

void calc::SetFunction(char* lpszCommand)
{
	strncpy(Function,lpszCommand,255);
	Function[255]=0;
	pCurrPos=Function;
}

double calc::proceed()
{
	if (strlen(Function)<1) throw(SyntaxError("No Expression"));
	return add_sub();
}

double calc::add_sub()
{
	double left=mul_div();
	while(true)
	{
		switch (*TokenValue) 
		{
		case '+':  left+=mul_div(); break;
		case '-': left-=mul_div();break;
		default: return left;
		}
		
	}

}

double calc::mul_div()
{
	double left=prim();
	while (true) 
	{
		switch(*TokenValue)
		{
		case '(': if(pCurrPos-Function)pCurrPos--;
				//     *    .
				//             prim
			//     1     
		case '*': left*=prim();break;
		case '/': { double d=prim();
					if(d==0) throw(divzero());
					left/=d; 
					break;}
		case '%': { double d=prim();//  
					if(d==0) throw(divzero());
					left=(int)left%(int)d; 
					break;}
		case '^': { double power=prim();
					if (left==0&&power<=0)throw MathError("Raising zero into power that is not greater than 0");
					double unused;
					if (modf(power,&unused)==0)
					{
						int p1=(int)power;
						power=left;//      
						for(int i=1;i<abs(p1);i++)left*=power;//  for(int i=0,i<p1-1,i++)
						if (p1<0)left=1/left;
						break;
					}
					//else
					if(left<0)throw(MathError("Raising number, that is less than zero into not integer power"));
					left=exp(log(left)*power);
					break;
				  }//case '^'

		default:return left;
		}//switch

	}//while
}

double calc::prim()
{
	GetToken();
	switch(CurrTok)
	{
	case NUMBER:
		{
			double temp=atof(TokenValue);
			GetToken();
			return temp;
		}
	case OPERATOR:
		{
			switch(*TokenValue)
			{
				case '-':return -prim();
				case '+':return prim();
				case '(':
					{
						double temp=add_sub();
						if(*TokenValue!=')') throw(SyntaxError(") expected"));
						GetToken();
						return temp;
					}
			}//end switch(TokenValue)
			throw(SyntaxError("Incorrect operator"));
		}//end case OPERATOR
	case FUNC:
		{
			if(strcmp(TokenValue,"abs")==0)return fabs(prim());
			if(strcmp(TokenValue,"sin")==0)return sin(prim());
			if(strcmp(TokenValue,"cos")==0)return cos(prim());
			if(strcmp(TokenValue,"tg")==0)//
			{
				double angle=prim();
				double temp= cos(angle);
				if(temp==0) throw(MathError("can't calculate tg"));
				return sin(angle)/temp;

			}
			if (strcmp(TokenValue,"ctg")==0)
			{
				double angle=prim();
				double temp= sin(angle);
				if(temp==0) throw(MathError("can't calculate tg"));
				return cos(angle)/temp;

			}
			if (strcmp(TokenValue,"ln")==0)
			{
				double temp=prim();
				if(temp<=0) throw(MathError("argument of lg is <= zero"));
				return log(temp);
			}
			if (strcmp(TokenValue,"exp")==0) return exp(prim());
			if (strcmp(TokenValue,"asin")==0)
			{
				double temp=prim();
				if(temp<-1||temp>1)throw(MathError("argument of asin is out of ranges"));
				return asin(temp);
			}
			if (strcmp(TokenValue,"acos")==0)
			{
				double temp=prim();
				if(temp<-1||temp>1)throw(MathError("argument of acos is out of ranges"));
				return acos(temp);
			}
			throw(SyntaxError("Incorrect function"));
		}
	default:throw(SyntaxError("No Expression"));
	}

}

void calc::GetToken()
{
	if(!pCurrPos){ CurrTok=END; *TokenValue=0; return;}// 
	while(*pCurrPos==' ')pCurrPos++;//   
//	TokenValue=UNDEF; // 
	
	char* temp=TokenValue;
	if(isdigit(*pCurrPos))
	{
		CurrTok=NUMBER;
		while(isdigit(*pCurrPos)||(*pCurrPos=='.'))*temp++=*pCurrPos++;
//		*temp=0;

	}
	else if(strchr("+-*/%^()",*pCurrPos))
	{
		CurrTok=OPERATOR;
		//   
		*temp++=*pCurrPos++;//  TokenValue 
//		*temp=0;
	}
	else if(islower(*pCurrPos))//  .      
	{
		while(islower(*pCurrPos))*temp++=*pCurrPos++;
		CurrTok=FUNC;
	}
	else CurrTok=END;
	*temp=0;
}

